--
--    *********** Script ecrit par David MONTET le 26/02/2004 *************
--
--ROLE : Permet d'enregistrer les coordonns de l'usager  partir de la table FLECS_USAGER
--(numero,  civilite, nom_usage, ....)

-- La table de thmes doit tre monte

-- ATTENTION : la cle primaire de FLECS_USER est la mme que USAGER !!!!!!!!!!!!!!!!!


BEGIN TRAN create_objet
SET NOCOUNT ON
PRINT '-------- DEBUT TRANCSAC REMONTER USAGER <MonterUsager.sql>--------'

DECLARE 
/* pour l'usager */
        @date_c  datetime,
	@date_m  datetime,
	@num	 char(8),
	@exp	 varchar(75),
	@exp2    varchar(75), 	
	@exp3    varchar(75),
	@nrue    char(5),
	@rue     char(32),
	@cpl_rue char(26),
	@cp      char(5),
	@ville   char(32),
	@id_utilisateur int,
	@comment  char(10),

/* Pour l'objet gnr */
	@mot_cle char(20),
	@idf  char(8),  /* Rfrence de FLECS <=>id_usager */
	@idth int,

/* Pour les actions */
	@ref_action     int,
	@numero_dossier int,
	@date_action  datetime,
	@date_prec datetime,
	@date_tri  char(8),
	@action1      VARCHAR(75),
	@action2      VARCHAR(75),
	@action3      VARCHAR(75),
	@action4      VARCHAR(75),
	@action5      VARCHAR(75),
	@id_obj      int


DECLARE c1 CURSOR FOR 
SELECT ref, date_creation, date_modification, numero, expediteur, expediteur2, expediteur3, num_rue, rue, complement_rue, codepostal, ville,mot_cle FROM FLECS_USAGER ORDER BY ref

UPDATE flecs_usager SET ref='00000001' WHERE login='YY16543' AND date_creation='19930831' AND numero='00001283' AND codepostal='31500' AND ville='TOULOUSE' AND mot_cle='AFFAIRE MILITAIRE'
UPDATE FLECS_ACTION SET ref='00000001' WHERE RTRIM(LTRIM(ref))=',' AND numero='00001281'
DELETE flecs_usager WHERE numero='0' AND expediteur=';'


OPEN c1
FETCH NEXT FROM c1 INTO @idf, @date_c, @date_m, @num, @exp, @exp2, @exp3, @nrue, @rue, @cpl_rue, @cp, @ville, @mot_cle


WHILE @@FETCH_STATUS = 0
BEGIN

    -- Coordonnes de l'usager dans la table
   INSERT INTO usager (id_usager, numero, nom_usager, num_rue, lib_off, rue2, id_secteur_postal, ville,date_creation, date_modif)
   VALUES (@idf, RTRIM(LTRIM(@num)), LTRIM(RTRIM (@exp+@exp2+@exp3)), LTRIM(RTRIM(@nrue)),LTRIM(RTRIM( @rue)), @cpl_rue, @cp, RTRIM(@ville), @date_c, @date_m )

   -- Cration d'un objet a partir du mot cl
   DECLARE c2 CURSOR FOR 
   SELECT id_theme FROM theme  WHERE UPPER(theme) = UPPER ( @mot_cle )
   OPEN c2
   FETCH NEXT FROM c2 INTO @idth	
       INSERT INTO objet (objet, id_theme, id_usager) VALUES ('Reprise FLECS ('+RTRIM(@mot_cle)+')', @idth, @idf)      	
   CLOSE c2
   DEALLOCATE c2

   -- Creation des actions
  Set @id_obj =  @@identity     /*On mmorise la cl primaire de l'objet que l'on vient d'insrer */

  DECLARE c3 CURSOR FOR 
  SELECT ref, numero, date_action, action1, action2, action3, action4, action5  FROM FLECS_ACTION WHERE RTRIM(ref) = RTRIM(@idf)  ORDER BY ref, numero, num_action, date_action
  OPEN c3
  FETCH NEXT FROM c3 INTO @ref_action, @numero_dossier, @date_action, @action1, @action2, @action3, @action4, @action5
  If (@date_action IS NOT NULL)
     Set @date_prec = @date_action
 
  -- parcours de la table flecs_action
  WHILE @@FETCH_STATUS = 0
  BEGIN          
        IF ( @date_action IS NULL OR @date_action='')
	begin
   	    INSERT INTO ACTION ( action, reponse, id_objet, date_tri ) VALUES ( @action1+'<br>'+@action2+'<br>'+@action3+'<br>'+@action4+'<br>'+@action5 ,0, @id_obj, @date_prec+1)   
	    Set @date_prec = @date_prec + 1
	end
	ELSE
	BEGIN
	    INSERT INTO action (date_action, action, reponse, id_objet, date_tri) VALUES ( @date_action, @action1+'<br>'+@action2+'<br>'+@action3+'<br>'+@action4+'<br>'+@action5, 0 , @id_obj, @date_action)
	      Set @date_prec = @date_action
	END	
	
	
      FETCH NEXT FROM c3 INTO @ref_action, @numero_dossier, @date_action, @action1, @action2, @action3, @action4, @action5	
  END
  CLOSE c3
  DEALLOCATE c3

 -- Usager suivant
 FETCH NEXT FROM c1 INTO  @idf, @date_c, @date_m, @num, @exp, @exp2, @exp3, @nrue, @rue, @cpl_rue, @cp, @ville, @mot_cle

END

CLOSE c1
DEALLOCATE c1

PRINT '-------- FIN TRANCSAC REMONTER USAGER <MonterUsager.sql>--------'
print '---->> REMETTRE IDENTITY de usager A ON !!!!!!!!!!!!!!!!!!!'
COMMIT TRAN create_objet