/*

	SCRIPT qui charge la table des parametres avec des valeurs par dfaut pour tous les services
*/


BEGIN TRAN create_id_util
SET NOCOUNT ON
PRINT '-------- DEBUT TRANCSAC <MonterParametre.sql>--------'

DECLARE 
	@ids      int

DECLARE c1 CURSOR FOR 
SELECT id_service FROM t_ann_service ORDER BY id_service

OPEN c1
FETCH NEXT FROM c1 INTO @ids


WHILE @@FETCH_STATUS = 0
BEGIN
	
INSERT INTO PARAMETRES (chemin,nom_application, timeout, tri_default, nom_serveur,
			menu_option1, menu_option2, menu_option3, menu_option4, 
			nb_action, libelle_requete,libelle_action, libelle_recom, libelle_theme, 
			libelle_doublon, libelle_fin_form, libelle_annuler,
			libelle_rech_voie,  ville_default, pays_default,
			annee_min, nb_jour_max_recents, dernier_dossier, 
			rech_onglet1, rech_onglet2, rech_onglet3, rech_onglet4,
			modif_onglet1, modif_onglet2,
			version, code_nouveau_default,
			recherche_default, nb_recherche, 
			id_service)   VALUES ('C:\','SD4', 35, 'DESC', 'Siintra163',
		'Nouveau dossier', 'Dossiers', 'Mot de passe', 'Suppression ',
		10, 'requte', 'action', 'recommandeur','Thme',
		'DOUBLON','Valider (FIN)', 'Annuler', 'Rechercher la voie', 'TOULOUSE', 'FRANCE', 1860, 200, 20490,
		'Par Noms','Plein Texte','Par Critres','Par Quartiers',		
		+'DOSSIER', 'SUIVI', '1.03', 'EMP', 'nom', 5, @ids)

	FETCH NEXT FROM c1 INTO @ids
END

CLOSE c1
DEALLOCATE c1

PRINT '-------- FIN TRANCSAC  <MonterParametre.sql>--------'

COMMIT TRAN create_id_util

